#include "IRLibAll.h"

int ENABLE = 4;
// Linker Getriebemotor
int IN1 = 9;
int IN2 = 10;
// Rechter Getriebemotor
int IN3 = 5;
int IN4 = 6;

// Geschwindigkeitsbestimmung
int pwm = 0;

// Richtungsbestimmung
int Richtung = 0;
int Fgo = 8;           // Vorwaerts
int Rgo = 6;           // Rechts
int Lgo = 4;           // Links
int Bgo = 2;           // Rückwärts

// Ultraschall
int trigger = 11;
int echo = 12;
long dauer = 0;
long entfernung = 0;

// Infrarot
IRrecvPCI myReceiver(3);
IRdecode myDecoder;

void setup() {
  Serial.begin(9600);
  // Motoren
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  // pinMode(ENABLE, OUTPUT);

  // Ultraschall
  pinMode(trigger, OUTPUT);
  pinMode(echo, INPUT);

  // Infrarot
  delay(2000); while (!Serial);
  myReceiver.enableIRIn();
  pinMode(3, OUTPUT);
}

// Motorbewegungen
void moveforward (int pwm) {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
}

void moveforwardright (int pwm) {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, 0);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, 50);
}

void moveforwardleft(int pwm) {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, 50);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, 0);
}

void movebackward (int pwm) {
  digitalWrite(IN1, LOW);
  digitalWrite(IN2, HIGH);
  digitalWrite(IN3, LOW);
  digitalWrite(IN4, HIGH);
}

void stopp (int pwm) {
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, HIGH);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, HIGH);
}

void loop() {
  // Motoren - Bewegung vorwärts
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2, LOW);
  analogWrite(IN2, 50);
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4, LOW);
  analogWrite(IN4, 50);
  
  //Infrarot
  if (myReceiver.getResults()) {
    myDecoder.decode();
    myDecoder.dumpResults(true);
    myReceiver.enableIRIn();
    Serial.println("detected");
  }
}

void UltraschallMess(){
  digitalWrite(trigger, LOW);
  delay(5);
  digitalWrite(trigger, HIGH);
  delay(10);
  digitalWrite(trigger, LOW);
  dauer = pulseIn(echo, HIGH);
  entfernung = (dauer / 2) * 0.03432;
}

void detection() {
  UltraschallMess();
  if (entfernung <= 70) {
    stopp(0);
    movebackward(30);
  }
  if (entfernung >= 60) {
    moveforward(50);
  }
}


